/*

  See HID Project documentation for more Consumer keys:
  https://github.com/NicoHood/HID/wiki/Consumer-API



  Logos erstellt:
  
  - Logos gesucht
  - In Corel:
    - 20% breiter gemacht
    - konvertiert in schwarz-weiß
    - auf 40px Höhe skaliert
    - auf 80px Breite erweitert
    - als BMP gespeichert
  - Unter http://javl.github.io/image2cpp/ eingelesen und Code für die Bilder erstellt

  
  Bisher keine Libraries verwendet, die Doppelklick und solche Sachen bei Buttons können.
  Wäre aber sicher hilfreich, leider erst danach gesucht, als ich mein Zeug schon fertig hatte.
  Das hier wären Kandidaten:
  
  http://jmsarduino.blogspot.de/2009/10/4-way-button-click-double-click-hold.html
  http://www.mathertel.de/Arduino/OneButtonLibrary.aspx
  http://www.instructables.com/id/Arduino-Dual-Function-Button-Long-PressShort-Press/?ALLSTEPS
  http://forum.arduino.cc/index.php?topic=14479.0


*/



// Including the special multimedia keys (see https://github.com/NicoHood/HID):
#include "HID-Project.h"

// Debouncing the buttons:
//
//  Library: http://playground.arduino.cc/Code/Bounce
//  Example: https://github.com/thomasfredericks/Bounce2/blob/master/examples/bounce2buttons/bounce2buttons.ino
//
//  Andere (und schlichtere) Lösung: https://www.youtube.com/watch?v=jYOYgU2vlSE
#include "Bounce2.h"

// Libraries for the Nokia 5110 display:
#include <SPI.h>
#include <Adafruit_GFX.h>
#include <Adafruit_PCD8544.h>


// Software SPI (slower updates, more flexible pin options):
#define PIN_CLK  6  // Serial clock out (SCLK)
#define PIN_DIN  5  // Serial data out (DIN)
#define PIN_DC   4  // Data/Command select (D/C)
#define PIN_CS   3  // LCD chip select (CS)
#define PIN_RST  2  // LCD reset (RST)
Adafruit_PCD8544 display = Adafruit_PCD8544(PIN_CLK, PIN_DIN, PIN_DC, PIN_CS, PIN_RST);


// Define the button pins:
#define BUTTON_PIN_1 15    // VOLUME DOWN
#define BUTTON_PIN_2 14    // VOLUME UP
#define BUTTON_PIN_3 20    // BACKWARD
#define BUTTON_PIN_4 19    // PLAY / PAUSE
#define BUTTON_PIN_5 18    // FORWARD


// Instantiate the (De-) Bounce objects:
Bounce debouncer1 = Bounce();
Bounce debouncer2 = Bounce();
Bounce debouncer3 = Bounce();
Bounce debouncer4 = Bounce();
Bounce debouncer5 = Bounce();


int previousButtonState1 = HIGH;
int previousButtonState2 = HIGH;
int previousButtonState3 = HIGH;
int previousButtonState4 = HIGH;
int previousButtonState5 = HIGH;

// Spotify or Youtube or Scroll?
int programm = 1; // 1: spotify // 2: youtube // 3: scroll 

// default state of some variables:
int pressedmute = 0;
int programchange = 1;

// press and hold button:
unsigned long millis_first = 0; // how long since the button was first pressed



static const unsigned char PROGMEM logo_spotify [] = {
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0xe0,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7f, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x03, 0xff, 0xff, 0xe0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0xff, 0xff, 0xf8, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x1f, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7f,
  0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0x80, 0x00, 0x00,
  0x00, 0x00, 0x01, 0xff, 0xff, 0xff, 0xff, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x03, 0xff, 0xff, 0xff,
  0xff, 0xe0, 0x00, 0x00, 0x00, 0x00, 0x03, 0xff, 0xff, 0xff, 0xff, 0xe0, 0x00, 0x00, 0x00, 0x00,
  0x07, 0xfe, 0x00, 0x0f, 0xff, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x0f, 0xc0, 0x00, 0x00, 0x3f, 0xf8,
  0x00, 0x00, 0x00, 0x00, 0x0f, 0xc0, 0x00, 0x00, 0x07, 0xf8, 0x00, 0x00, 0x00, 0x00, 0x1f, 0xc0,
  0x7f, 0xc0, 0x01, 0xf8, 0x00, 0x00, 0x00, 0x00, 0x1f, 0xff, 0xff, 0xff, 0x00, 0xfc, 0x00, 0x00,
  0x00, 0x00, 0x1f, 0xff, 0xff, 0xff, 0xe0, 0xfc, 0x00, 0x00, 0x00, 0x00, 0x1f, 0xff, 0x80, 0x7f,
  0xf9, 0xfc, 0x00, 0x00, 0x00, 0x00, 0x1f, 0xf0, 0x00, 0x01, 0xff, 0xfc, 0x00, 0x00, 0x00, 0x00,
  0x1f, 0xe0, 0x00, 0x00, 0x3f, 0xfc, 0x00, 0x00, 0x00, 0x00, 0x1f, 0xe1, 0xff, 0xe0, 0x0f, 0xfc,
  0x00, 0x00, 0x00, 0x00, 0x1f, 0xff, 0xff, 0xfe, 0x07, 0xfc, 0x00, 0x00, 0x00, 0x00, 0x1f, 0xff,
  0xff, 0xff, 0xc7, 0xfc, 0x00, 0x00, 0x00, 0x00, 0x1f, 0xff, 0x00, 0x3f, 0xff, 0xfc, 0x00, 0x00,
  0x00, 0x00, 0x1f, 0xf0, 0x00, 0x03, 0xff, 0xf8, 0x00, 0x00, 0x00, 0x00, 0x0f, 0xf0, 0x1f, 0x00,
  0x7f, 0xf8, 0x00, 0x00, 0x00, 0x00, 0x0f, 0xff, 0xff, 0xf8, 0x3f, 0xf8, 0x00, 0x00, 0x00, 0x00,
  0x07, 0xff, 0xff, 0xff, 0x3f, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x03, 0xff, 0xff, 0xff, 0xff, 0xe0,
  0x00, 0x00, 0x00, 0x00, 0x03, 0xff, 0xff, 0xff, 0xff, 0xe0, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff,
  0xff, 0xff, 0xff, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0x80, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x7f, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3f, 0xff, 0xff,
  0xfc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0xff, 0xff, 0xf8, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x03, 0xff, 0xff, 0xe0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7f, 0xff, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
};
static const unsigned char PROGMEM logo_youtube [] = {
  0x00, 0x03, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe0, 0x00, 0x00, 0x1f, 0xff, 0xff, 0xff, 0xff,
  0xff, 0xff, 0xfc, 0x00, 0x00, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfe, 0x00, 0x00, 0x7f,
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
  0xff, 0x80, 0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x80, 0x00, 0xff, 0xff, 0xff,
  0xff, 0xff, 0xff, 0xff, 0xff, 0x80, 0x01, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0,
  0x01, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0x01, 0xff, 0xff, 0xff, 0xff, 0xff,
  0xff, 0xff, 0xff, 0xc0, 0x01, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0x01, 0xff,
  0xff, 0xff, 0xdf, 0xff, 0xff, 0xff, 0xff, 0xc0, 0x01, 0xff, 0xff, 0xff, 0xc7, 0xff, 0xff, 0xff,
  0xff, 0xc0, 0x01, 0xff, 0xff, 0xff, 0xc1, 0xff, 0xff, 0xff, 0xff, 0xc0, 0x01, 0xff, 0xff, 0xff,
  0xc0, 0x3f, 0xff, 0xff, 0xff, 0xc0, 0x01, 0xff, 0xff, 0xff, 0xc0, 0x0f, 0xff, 0xff, 0xff, 0xc0,
  0x01, 0xff, 0xff, 0xff, 0xc0, 0x03, 0xff, 0xff, 0xff, 0xc0, 0x01, 0xff, 0xff, 0xff, 0xc0, 0x00,
  0x7f, 0xff, 0xff, 0xc0, 0x01, 0xff, 0xff, 0xff, 0xc0, 0x00, 0x1f, 0xff, 0xff, 0xc0, 0x01, 0xff,
  0xff, 0xff, 0xc0, 0x00, 0x3f, 0xff, 0xff, 0xc0, 0x01, 0xff, 0xff, 0xff, 0xc0, 0x00, 0xff, 0xff,
  0xff, 0xc0, 0x01, 0xff, 0xff, 0xff, 0xc0, 0x03, 0xff, 0xff, 0xff, 0xc0, 0x01, 0xff, 0xff, 0xff,
  0xc0, 0x0f, 0xff, 0xff, 0xff, 0xc0, 0x01, 0xff, 0xff, 0xff, 0xc0, 0x7f, 0xff, 0xff, 0xff, 0xc0,
  0x01, 0xff, 0xff, 0xff, 0xc1, 0xff, 0xff, 0xff, 0xff, 0xc0, 0x01, 0xff, 0xff, 0xff, 0xc7, 0xff,
  0xff, 0xff, 0xff, 0xc0, 0x01, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0x01, 0xff,
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0x01, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
  0xff, 0xc0, 0x01, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0x01, 0xff, 0xff, 0xff,
  0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0x01, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0,
  0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x80, 0x00, 0xff, 0xff, 0xff, 0xff, 0xff,
  0xff, 0xff, 0xff, 0x80, 0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x80, 0x00, 0x7f,
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
  0xfe, 0x00, 0x00, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x03, 0xff, 0xff,
  0xff, 0xff, 0xff, 0xff, 0xe0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
};
static const unsigned char PROGMEM logo_scroll [] = {
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x01, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0xc0, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x1f, 0xf8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3f, 0xfc, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x7f, 0xfe, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0xff, 0xff, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x07, 0xff, 0xff, 0xe0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0xff, 0xff, 0xf0, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x1f, 0xff, 0xff, 0xf8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3f, 
  0xff, 0xff, 0xfc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x01, 0xff, 0xff, 0xff, 0xff, 0x80, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xff, 0xff, 
  0xff, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 
  0xff, 0xff, 0xff, 0x80, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff, 0xff, 0xff, 0xff, 0x80, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7f, 0xff, 0xff, 
  0xfc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1f, 0xff, 0xff, 0xf8, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x0f, 0xff, 0xff, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0xff, 0xff, 0xe0, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0xff, 0xff, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7f, 0xfe, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x3f, 0xfc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1f, 0xf8, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x03, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x80, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
};




void setup() {

  // make the pushButton pin an input:
  pinMode(BUTTON_PIN_1, INPUT);
  pinMode(BUTTON_PIN_2, INPUT);
  pinMode(BUTTON_PIN_3, INPUT);
  pinMode(BUTTON_PIN_4, INPUT);
  pinMode(BUTTON_PIN_5, INPUT);

  // activate internal pull-up:
  digitalWrite(BUTTON_PIN_1, INPUT_PULLUP);
  digitalWrite(BUTTON_PIN_2, INPUT_PULLUP);
  digitalWrite(BUTTON_PIN_3, INPUT_PULLUP);
  digitalWrite(BUTTON_PIN_4, INPUT_PULLUP);
  digitalWrite(BUTTON_PIN_5, INPUT_PULLUP);

  // define display pins as outputs:
  pinMode(PIN_CLK, OUTPUT);
  pinMode(PIN_DIN, OUTPUT);
  pinMode(PIN_DC, OUTPUT);
  pinMode(PIN_CS, OUTPUT);
  pinMode(PIN_RST, OUTPUT);



  // after setting up the button, setup the Bounce instance:
  debouncer1.attach(BUTTON_PIN_1);  debouncer1.interval(50);
  debouncer2.attach(BUTTON_PIN_2);  debouncer2.interval(50);
  debouncer3.attach(BUTTON_PIN_3);  debouncer3.interval(50);
  debouncer4.attach(BUTTON_PIN_4);  debouncer4.interval(50);
  debouncer5.attach(BUTTON_PIN_5);  debouncer5.interval(50);


  // sends a clean report to the host. This is important on any Arduino type:
  Consumer.begin();
  // Sends a clean report to the host. This is important on any Arduino type.
  AbsoluteMouse.begin();

  
  // initialize display:
  display.begin();

  // optimizing the contrast:
    //  int contrast = 10;
    //  int contrastincr = 5;
    //  while(1) {
    //    
    //    display.clearDisplay();
    //    display.setContrast(contrast);
    //  
    //    display.setCursor(10,40);
    //    display.setTextColor(BLACK);
    //    display.setTextSize(1);
    //    display.println("Press button");
    //  
    //    display.setCursor(20,0);
    //    // display.setTextColor(WHITE, BLACK); // 'inverted' text
    //    display.setTextColor(BLACK);
    //    display.setTextSize(4);
    //    display.println(contrast);
    //    display.display();
    //
    //    // stop contrast incr. when button is pressed:
    //    for(int i=1; i<=10; i++) {
    //      // Update the Bounce instances :
    //      debouncer1.update();
    //      debouncer2.update();
    //      debouncer3.update();
    //      debouncer4.update();
    //      debouncer5.update();
    //    
    //      // set contrast and end loop if button is pressed:
    //      if (debouncer1.read() == LOW || debouncer2.read() == LOW || debouncer3.read() == LOW || debouncer4.read() == LOW || debouncer5.read() == LOW) {
    //        goto end_contrast_opt;
    //        }
    //      delay(100);
    //    }
    //    contrast += contrastincr;
    //    if((contrastincr > 0 && contrast == 80) || (contrastincr < 0 && contrast == 20)) {contrastincr = -contrastincr;}
    //  }
    //  end_contrast_opt:


  // if you know the perfect contrast already:
  int contrast = 55;
  display.clearDisplay();
  display.setContrast(contrast);


  // set the correct logo at the start:
  if (programm == 1) {
    display.clearDisplay();
    display.drawBitmap(0, 0,  logo_spotify, 80, 40, 1);
    display.display();
  }
  else if (programm == 2) {
    display.clearDisplay();
    display.drawBitmap(0, 0,  logo_youtube, 80, 40, 1);
    display.display();
  }
  else if (programm == 3) {
    display.clearDisplay();
    display.drawBitmap(0, 0,  logo_scroll, 80, 40, 1);
    display.display();
  }

} 






void loop() {

  // update the Bounce instances :
  debouncer1.update();
  debouncer2.update();
  debouncer3.update();
  debouncer4.update();
  debouncer5.update();

  // read the pushbuttons:
  int buttonState1 = debouncer1.read();
  int buttonState2 = debouncer2.read();
  int buttonState3 = debouncer3.read();
  int buttonState4 = debouncer4.read();
  int buttonState5 = debouncer5.read();
  //   without debouncing:
  //   int buttonState1 = digitalRead(BUTTON_PIN_1);






  // VOLUME BUTTONS:

  // VOLUME DOWN:
  if (pressedmute == 0) {
    if (buttonState1 == LOW) {
      if ((buttonState2 != previousButtonState2) && (buttonState2 == LOW)) {
        Consumer.write(MEDIA_VOLUME_MUTE);
        pressedmute = 1;
        delay(500);
      }
      else if (buttonState2 == HIGH) {
        Consumer.write(MEDIA_VOLUME_DOWN);
        delay(250); // sonst läuft es zu schnell...
      }
    }
  }

  // VOLUME UP:
  if (pressedmute == 0) {
    if (buttonState2 == LOW) {
      if ((buttonState1 != previousButtonState1) && (buttonState1 == LOW)) {
        Consumer.write(MEDIA_VOLUME_MUTE);
        pressedmute = 1;
        delay(500);
      }
      else if (buttonState1 == HIGH) {
        Consumer.write(MEDIA_VOLUME_UP);
        delay(150); // sonst läuft es zu schnell...
      }
    }
  }
  
  if ((buttonState1 == HIGH) && (buttonState2 == HIGH)) {
    pressedmute = 0;
  }









  // PROGRAM BUTTONS:

  // SPOTIFY:
  if (programm == 1) {
    // PLAY / PAUSE:
    if ((buttonState4 != previousButtonState4) && (buttonState4 == LOW)) {      // ACHTUNG: LOW schaltet beim Runterdrücken, HIGH würde erst beinm Loslassen schalten
      // measure the time the button is pressed:
      millis_first = millis();
    }
    else if ((buttonState4 != previousButtonState4) && (buttonState4 == HIGH)) {
      if ((millis() - millis_first) < 1500) {
        if (programchange == 1) {
          programchange = 0;
        }
        else {
          Consumer.write(MEDIA_PLAY_PAUSE);  
        }
        
      }
    }
    // check how long the button is pressed:
    else if (buttonState4 == LOW) {
      if ((millis() - millis_first) > 1500) {
        // switch to youtube:
        programm = 2;
        //change the logo:
        display.clearDisplay();
        display.drawBitmap(0, 0,  logo_youtube, 80, 40, 1);
        display.display();
        // reset the clock:
        millis_first = millis();
        programchange = 1;
      }
    }
    // LAST TRACK:
    if ((buttonState3 != previousButtonState3) && (buttonState3 == LOW)) {
      Consumer.write(MEDIA_PREVIOUS);
    }
    // NEXT TRACK:
    if ((buttonState5 != previousButtonState5) && (buttonState5 == LOW)) {
      //Consumer.write(MEDIA_NEXT);
      AbsoluteMouse.click(MOUSE_LEFT);  // Sending left mouse click to jump to a specific position in a song
    }
  }


  
  // YOUTUBE:
  else if (programm == 2) {
    // PLAY / PAUSE:
    if ((buttonState4 != previousButtonState4) && (buttonState4 == LOW)) {
      // measure the time the button is pressed:
      millis_first = millis();
    }
    else if ((buttonState4 != previousButtonState4) && (buttonState4 == HIGH)) {
      if ((millis() - millis_first) < 1500) {
        if (programchange == 1) {
          programchange = 0;
        }
        else {
          // Keyboard.print("k");
          // Ein "k" zu senden ist auf Youtube zwar der sicherere Weg, allerdings ist " " flexibler (auch Vimeo, Songsterr, VLC, ...)
          Keyboard.print(" ");
        }
      }
    }
    // check how long the button is pressed:
    else if (buttonState4 == LOW) {
      if ((millis() - millis_first) > 1500) {
        // switch to scroll:
        programm = 3;
        //change the logo:
        display.clearDisplay();
        display.drawBitmap(0, 0,  logo_scroll, 80, 40, 1);
        display.display();
        // reset the clock:
        millis_first = millis();
        programchange = 1;
      }
    }
    // FAST  BACKWARD:
    if (buttonState3 == LOW) {
      //Keyboard.print("j");  // 10 seconds
      Keyboard.press(KEY_LEFT_ARROW); // 5 seconds
    }
    if ((buttonState3 != previousButtonState3) && (buttonState3 == HIGH)) {
      Keyboard.release(KEY_LEFT_ARROW);
    }
    // FAST FORWARD:
    if (buttonState5 == LOW) {
      //Keyboard.print("l");  // 10 seconds
      Keyboard.press(KEY_RIGHT_ARROW); // 5 seconds
    }
    if ((buttonState5 != previousButtonState5) && (buttonState5 == HIGH)) {
      Keyboard.release(KEY_RIGHT_ARROW);
    }
  }


  
  // SCROLL:
  else  if (programm == 3) {
    // PLAY / PAUSE:
    if ((buttonState4 != previousButtonState4) && (buttonState4 == LOW)) {
      // measure the time the button is pressed:
      millis_first = millis();
    }
    else if ((buttonState4 != previousButtonState4) && (buttonState4 == HIGH)) {
      if ((millis() - millis_first) < 1500) {
        if (programchange == 1) {
          programchange = 0;
        }
        else {
          Consumer.write(MEDIA_PLAY_PAUSE);
        }
      }
    }
    // check how long the button is pressed:
    else if (buttonState4 == LOW) {
      if ((millis() - millis_first) > 1500) {
        // switch to spotify:
        programm = 1;
        //change the logo:
        display.clearDisplay();
        display.drawBitmap(0, 0,  logo_spotify, 80, 40, 1);
        display.display();
        // reset the clock:
        millis_first = millis();
        programchange = 1;
      }
    }
    // SCROLL DOWN:
    if (buttonState5 == LOW) {
      Keyboard.press(KEY_DOWN_ARROW);
    }
    if ((buttonState5 != previousButtonState5) && (buttonState5 == HIGH)) {
      Keyboard.release(KEY_DOWN_ARROW);
    }
    // SCROLL UP:
    if (buttonState3 == LOW) {
      Keyboard.press(KEY_UP_ARROW);
    }
    if ((buttonState3 != previousButtonState3) && (buttonState3 == HIGH)) {
      Keyboard.release(KEY_UP_ARROW);
    }
  }





  // Save the current button state for comparison next time:
  previousButtonState1 = buttonState1;
  previousButtonState2 = buttonState2;
  previousButtonState3 = buttonState3;
  previousButtonState4 = buttonState4;
  previousButtonState5 = buttonState5;
}



